VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Excel Controller"
   ClientHeight    =   3375
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5400
   LinkTopic       =   "Form1"
   ScaleHeight     =   3375
   ScaleWidth      =   5400
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdQuit 
      Caption         =   "Quit"
      Height          =   495
      Left            =   3720
      TabIndex        =   22
      Top             =   2520
      Width           =   855
   End
   Begin VB.CommandButton cmdEvaluateExpression 
      Caption         =   "Evaluate"
      Height          =   495
      Left            =   3720
      TabIndex        =   21
      Top             =   1920
      Width           =   855
   End
   Begin VB.CommandButton cmdChart 
      Caption         =   "Chart "
      Height          =   495
      Left            =   3720
      TabIndex        =   20
      Top             =   1440
      Width           =   855
   End
   Begin VB.CommandButton cmdCreateMatrix 
      Caption         =   "Create Matrix"
      Height          =   495
      Left            =   3720
      TabIndex        =   19
      Top             =   960
      Width           =   855
   End
   Begin VB.Frame Frame1 
      Caption         =   "Get or Put Matrix"
      Height          =   2175
      Left            =   120
      TabIndex        =   5
      Top             =   840
      Width           =   3255
      Begin VB.CommandButton cmdPutGetMatrix 
         Caption         =   "Put"
         Height          =   495
         Left            =   2160
         TabIndex        =   18
         Top             =   1200
         Width           =   735
      End
      Begin VB.OptionButton optGetMatrix 
         Caption         =   "Get"
         Height          =   255
         Left            =   2160
         TabIndex        =   17
         Top             =   720
         Width           =   735
      End
      Begin VB.OptionButton optPutMatrix 
         Caption         =   "Put"
         Height          =   255
         Left            =   2160
         TabIndex        =   16
         Top             =   360
         Value           =   -1  'True
         Width           =   735
      End
      Begin VB.TextBox txtEndCol 
         Alignment       =   1  'Right Justify
         Height          =   285
         Left            =   1320
         TabIndex        =   10
         Text            =   "5"
         Top             =   1800
         Width           =   615
      End
      Begin VB.TextBox txtEndRow 
         Alignment       =   1  'Right Justify
         Height          =   285
         Left            =   1320
         TabIndex        =   9
         Text            =   "4"
         Top             =   1440
         Width           =   615
      End
      Begin VB.TextBox txtStartCol 
         Alignment       =   1  'Right Justify
         Height          =   285
         Left            =   1320
         TabIndex        =   8
         Text            =   "2"
         Top             =   1080
         Width           =   615
      End
      Begin VB.TextBox txtStartRow 
         Alignment       =   1  'Right Justify
         Height          =   285
         Left            =   1320
         TabIndex        =   7
         Text            =   "1"
         Top             =   720
         Width           =   615
      End
      Begin VB.TextBox txtSheetNo 
         Alignment       =   1  'Right Justify
         Height          =   285
         Left            =   1320
         TabIndex        =   6
         Text            =   "1"
         Top             =   360
         Width           =   615
      End
      Begin VB.Label Label5 
         Caption         =   "End Col"
         Height          =   255
         Left            =   240
         TabIndex        =   15
         Top             =   1800
         Width           =   615
      End
      Begin VB.Label Label4 
         Caption         =   "End Row"
         Height          =   255
         Left            =   240
         TabIndex        =   14
         Top             =   1440
         Width           =   735
      End
      Begin VB.Label Label3 
         Caption         =   "Start Col"
         Height          =   255
         Left            =   240
         TabIndex        =   13
         Top             =   1080
         Width           =   735
      End
      Begin VB.Label Label2 
         Caption         =   "Start Row"
         Height          =   255
         Left            =   240
         TabIndex        =   12
         Top             =   720
         Width           =   855
      End
      Begin VB.Label Label1 
         Caption         =   "Sheet No"
         Height          =   255
         Left            =   240
         TabIndex        =   11
         Top             =   360
         Width           =   855
      End
   End
   Begin VB.CommandButton cmdSave 
      Caption         =   "Save"
      Height          =   495
      Left            =   3240
      TabIndex        =   4
      Top             =   120
      Width           =   975
   End
   Begin VB.CommandButton cmdQuitExcel 
      Caption         =   "Quit Excel"
      Height          =   495
      Left            =   4320
      TabIndex        =   3
      Top             =   120
      Width           =   975
   End
   Begin VB.CommandButton cmdHideShow 
      Caption         =   "Hide"
      Height          =   495
      Left            =   2280
      TabIndex        =   2
      Top             =   120
      Width           =   855
   End
   Begin VB.CommandButton cmdNew 
      Caption         =   "New"
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   975
   End
   Begin VB.CommandButton cmdOpen 
      Caption         =   "Open"
      Height          =   495
      Left            =   1200
      TabIndex        =   0
      Top             =   120
      Width           =   975
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'#####################################################################
' This code is provided as part of VB tutorial
' by Kardi Teknomo
' Visit http://people.revoledu.com/kardi/tutorial/VB/index.html
'#####################################################################

Private appExcel As Excel.Application
Private wBook As Workbook
Private mySheet As Worksheet
Private myChart As Chart
Private myRange As Range
Dim myMatrix
Dim sheetNo As Integer
Dim startRow As Integer, startCol As Integer
Dim endRow As Integer, endCol As Integer





Private Sub Form_Load()
    ' set the name
    Set appExcel = New Excel.Application
    appExcel.Application.Visible = True
End Sub


Private Sub cmdNew_Click()
    Set wBook = appExcel.Workbooks.Add
    Set mySheet = appExcel.Sheets(1)
End Sub


Private Sub cmdOpen_Click()
' Dialog to open spreadsheet from Excel
Dim fName
Dim sheetNo As Integer

    fName = appExcel.GetOpenFilename
    sheetNo = Val(txtSheetNo.Text)
    If fName <> False Then
        Set wBook = appExcel.Workbooks.Open(fName)
        Set mySheet = appExcel.Sheets(1)  ' set the name
    End If
End Sub


Private Sub cmdHideShow_Click()
    If cmdHideShow.Caption = "Hide" Then
        appExcel.Visible = False
        cmdHideShow.Caption = "Show"
    Else
        appExcel.Visible = True
        cmdHideShow.Caption = "Hide"
    End If
End Sub


Private Sub cmdSave_Click()
On Error GoTo errHandle

    appExcel.DisplayAlerts = True
    appExcel.Save
    Exit Sub
    
errHandle:
    MsgBox Err.Description
End Sub


Private Sub cmdQuitExcel_Click()
    On Error Resume Next
    appExcel.DisplayAlerts = False   ' don't ask to save
    appExcel.Application.Quit        ' quit Excel
    Set appExcel = Nothing           ' release reference to object
End Sub


Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    Call cmdQuitExcel_Click  'remove excel too if user quit this program
End Sub


Private Sub optGetMatrix_Click()
    txtEndRow.Visible = True
    txtEndCol.Visible = True
    cmdPutGetMatrix.Caption = "Get"
End Sub


Private Sub optPutMatrix_Click()
    txtEndRow.Visible = False
    txtEndCol.Visible = False
    cmdPutGetMatrix.Caption = "Put"
End Sub


Private Sub cmdPutGetMatrix_Click()
    Call GetValuesFromText
    If cmdPutGetMatrix.Caption = "Put" Then
        Call PutMatrix
    Else  ' Get matrix
        myMatrix = GetMatrix
    End If
    appExcel.Sheets(sheetNo).Activate
End Sub


Private Sub cmdCreateMatrix_Click()
Dim row As Integer, col As Integer
    Call GetValuesFromText   ' Put textboxes values into private variables
    ReDim myMatrix(1 To endRow - startRow + 1, 1 To endCol - startCol + 1)
    For row = 1 To UBound(myMatrix, 1)
        For col = 1 To UBound(myMatrix, 2)
            myMatrix(row, col) = Rnd * 100
        Next col
    Next row
End Sub




Private Sub GetValuesFromText()
' Put this values into private variables
    sheetNo = Val(txtSheetNo.Text)
    startRow = Val(txtStartRow.Text)
    startCol = Val(txtStartCol.Text)
    endRow = Val(txtEndRow.Text)
    endCol = Val(txtEndCol.Text)
End Sub


Private Function GetMatrix()
' Get matrix from Excel

    On Error GoTo errHandle
    GetMatrix = mySheet.Range(mySheet.Cells(startRow, startCol), mySheet.Cells(endRow, endCol))
    Exit Function
    
errHandle:
    MsgBox Err.Description
End Function


Private Sub PutMatrix()
' Put matrix in a sheet of Excel
Dim shtActive
Dim i As Integer, j As Integer
Dim endRow As Integer, endCol As Integer
    On Error GoTo errHandle
    
    endRow = UBound(myMatrix, 1) + startRow - 1
    endCol = UBound(myMatrix, 2) + startCol - 1
    Set shtActive = appExcel.Sheets(sheetNo)
    For i = startRow To endRow
        For j = startCol To endCol
            shtActive.Cells(i, j).Value = myMatrix(i - startRow + 1, j - startCol + 1)
        Next j
    Next i
    Exit Sub
    
errHandle:
    MsgBox Err.Description
End Sub



Private Sub cmdChart_Click()
    ' create new chart
    Set myChart = appExcel.Charts.Add
    
    'Determine the size of the range and store it.
    Set myRange = mySheet.Range(mySheet.Cells(startRow, startCol), mySheet.Cells(endRow, endCol))
    
    'Format the chart.
    With myChart
        ' Specify chart type as 3D.
        .ChartType = xlBarOfPie
        
        ' Set the range of the chart.
        .SetSourceData Source:=myRange, PlotBy:=xlColumns
        
        ' Specify that the chart is located on a new sheet.
        .Location Where:=xlLocationAsNewSheet
    End With
    Call myChart.Move  ' to other workbook
End Sub


Private Sub cmdEvaluateExpression_Click()
Dim expression
    On Error GoTo errHandle
    expression = InputBox("Enter mathematics expression " & vbCr & _
        "e.g. Sin(Cos(log(23)+30))", "Math Evaluator", "Sin(Cos(log(23)+30))")
    MsgBox expression & " = " & appExcel.Evaluate(expression), , "Result of Your Expression"
    Exit Sub
    
errHandle:
    MsgBox "I think you mistype your expression. Please try again", , "Error"
End Sub

Private Sub cmdQuit_Click()
    End
End Sub

